package org.example

import com.github.h0tk3y.betterParse.lexer.DefaultTokenizer
import com.github.h0tk3y.betterParse.lexer.Token
import com.github.h0tk3y.betterParse.lexer.literalToken
import com.github.h0tk3y.betterParse.lexer.regexToken


object RegexLexer {
    val char = regexToken("[a-zA-Z0-9]")
    val plus = literalToken("+")
    val star = literalToken("*")
    val question = literalToken("?")
    val dot = literalToken(".")
    val openParen = literalToken("(")
    val closeParen = literalToken(")")
    val alternation = literalToken("|")

    val tokenizer = DefaultTokenizer(
        listOf(char, plus, star, question, dot, openParen, closeParen, alternation)
    )
}